//+------------------------------------------------------------------+
//|                                                       #Grred.mq4 |
//|                                 Copyright  2010, XrustSolution. |
//|                                           mail: xrustx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, XrustSolution."
#property link      "mail: xrustx@gmail.com"

#property indicator_chart_window
extern    color     LineColor = DimGray;
int steps[]={2,5,10,20,50,100,200,500,1000,2000,5000,10000,20000,50000,100000};
void init(){Greed();return;}
void start(){Greed();return;}
void deinit(){DelGreed();return;}
//+------------------------------------------------------------------+
void Greed(){
      DelGreed();
      double winmax = NormalizeDouble(WindowPriceMax(),Digits);
      double winmin = NormalizeDouble(WindowPriceMin(),Digits);
      double prmax  = NormalizeDouble(High[iHighest(Symbol(),Period(),MODE_HIGH,Bars-10,1)],Digits);
      double prmin  = NormalizeDouble(Low [iLowest(Symbol(),Period(),MODE_LOW,Bars-10,0)],Digits);
      double max = MathMax(NormalizeDouble(WindowPriceMax(),Digits),
                                     NormalizeDouble(High[iHighest(Symbol(),Period(),MODE_HIGH,Bars-10,1)],Digits));
      double min = MathMin(NormalizeDouble(WindowPriceMin(),Digits),
                                     NormalizeDouble(Low [iLowest(Symbol(),Period(),MODE_LOW,Bars-10,0)],Digits));                               
      if(winmax == 0){winmax=max;}
      if(winmin == 0){winmin=min;}
      int    wd    = (winmax-winmin)/Point;
      for(int i=0;i<15;i++){
         int x = wd/steps[i];
         if(x<8){break;}
      }
      if(i>15){i=15;}
      int t = WindowBarsPerChart()-WindowFirstVisibleBar();
      if(t<0){t=0;}
      prmax=MathFloor(max);
      prmin=MathFloor(min);
      if(prmin>=winmin){prmin=winmin;}
      if(prmin<=1){prmin=0;}//NormalizeDouble(prmin,2);}
      Comment("step = "+steps[i]);
      int c = ((prmax-prmin)/Point)/steps[i];
      if(x>c){c=x;}
      for(int y = 0; y < c*2; y=y+2){ 
         string name = "grd"+y;
         ObjectCreate(name,OBJ_RECTANGLE,0,0,0,0,0,0,0);
            ObjectSet(name, OBJPROP_PRICE1, prmin+((steps[i]*y)*Point));
            ObjectSet(name, OBJPROP_PRICE2, prmin+((steps[i]*y)*Point)+(steps[i]*Point));
            ObjectSet(name, OBJPROP_TIME1 , Time[Bars-10]);
            ObjectSet(name, OBJPROP_TIME2 , Time[0]+(t*Period()*60));
            ObjectSet(name, OBJPROP_COLOR , LineColor);
            ObjectSet(name, OBJPROP_STYLE , 0);
            ObjectSet(name, OBJPROP_WIDTH , 1);
            ObjectSet(name, OBJPROP_BACK  , true); 
         name = "grdld"+y;   
         ObjectCreate(name,OBJ_HLINE,0,0,0,0,0,0,0);
            ObjectSet(name, OBJPROP_PRICE1, prmin+((steps[i]*y)*Point));
            ObjectSet(name, OBJPROP_COLOR , LineColor);
            ObjectSet(name, OBJPROP_STYLE , 0);
            ObjectSet(name, OBJPROP_WIDTH , 1);
            ObjectSet(name, OBJPROP_BACK  , true);     
         name = "grdlu"+y;   
         ObjectCreate(name,OBJ_HLINE,0,0,0,0,0,0,0);
            ObjectSet(name, OBJPROP_PRICE1, prmin+((steps[i]*y)*Point)+(steps[i]*Point));
            ObjectSet(name, OBJPROP_COLOR , LineColor);
            ObjectSet(name, OBJPROP_STYLE , 0);
            ObjectSet(name, OBJPROP_WIDTH , 1);
            ObjectSet(name, OBJPROP_BACK  , true);                    
      }
      WindowRedraw();  
}
//+------------------------------------------------------------------+
void DelGreed(){int i;
   for(i=ObjectsTotal()-1;i>=0;i--){
      string nm = ObjectName(i);
      if(StringFind(nm,"grd",0)<0){continue;}
      ObjectDelete(nm);
   }
   return;
}  

